package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

public class Contact {
    private static HashMap<String, String> sContactCache;
    private static final String TAG = "Contact";

    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";

     /**
     * 从通讯录中获取给定电话号码对应的联系人名字
     * @param context 应用程序上下文
     * @param phoneNumber 电话号码
     * @return 联系人名字，如果未找到则返回null
     */
    public static String getContact(Context context, String phoneNumber) {
        // 如果缓存为空，则初始化一个HashMap对象作为缓存
        if (sContactCache == null) {
            sContactCache = new HashMap<String, String>();
        }

        // 如果缓存中存在该电话号码对应的联系人名字，则直接返回
        if (sContactCache.containsKey(phoneNumber)) {
            return sContactCache.get(phoneNumber);
        }

        // 构造查询条件，使用给定的电话号码作为参数
        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));
        // 查询通讯录数据库，查询结果包含指定电话号码的联系人名字
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,
                new String[] { Phone.DISPLAY_NAME },
                selection,
                new String[] { phoneNumber },
                null);

        // 如果查询结果非空，则获取第一条结果中的联系人名字，并将其存入缓存
        if (cursor != null && cursor.moveToFirst()) {
            try {
                String name = cursor.getString(0);
                sContactCache.put(phoneNumber, name); // 将联系人名字存入缓存
                return name;
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
                cursor.close();
            }
        } else {
            // 如果查询结果为空，则记录日志并返回null
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }

}
